import { Handle } from 'dojo-core/interfaces';
import Promise from 'dojo-shim/Promise';
import { CombinedRegistry, RegistryProvider, StoreLike, WidgetLike } from '../createApp';
export declare function isValidName(name: string): boolean;
export declare function normalizeName(name: string): string;
/**
 * Realizes custom elements within a root element.
 *
 * @param defaultWidgetStore The default widget store of the app, may be null.
 * @param registerInstance Callback for registering new widget instances with the app
 * @param registry Read-only registry of actions, custom element factories, stores and widgets
 * @param registryProvider Registry provider, to be passed to custom element factories
 * @param root The element within which custom elements are realized
 *
 * @return A handle to detach rendered widgets from the DOM and remove them from the widget registry
 */
export default function realizeCustomElements(defaultWidgetStore: StoreLike, addIdentifier: (id: string) => Handle, registerInstance: (widget: WidgetLike, id: string) => Handle, registry: CombinedRegistry, registryProvider: RegistryProvider, root: Element): Promise<Handle>;
