(function (factory) {
    if (typeof module === 'object' && typeof module.exports === 'object') {
        var v = factory(require, exports); if (v !== undefined) module.exports = v;
    }
    else if (typeof define === 'function' && define.amd) {
        define(["require", "exports", 'dojo-shim/Promise'], factory);
    }
})(function (require, exports) {
    "use strict";
    var Promise_1 = require('dojo-shim/Promise');
    function resolveListeners(registry, ref) {
        if (Array.isArray(ref)) {
            var isSync = true;
            var results = [];
            for (var _i = 0, ref_1 = ref; _i < ref_1.length; _i++) {
                var item = ref_1[_i];
                var _a = resolveListeners(registry, item), value = _a[0], promise = _a[1];
                if (value) {
                    results.push(value);
                }
                else {
                    isSync = false;
                    results.push(promise);
                }
            }
            if (isSync) {
                return [results, undefined];
            }
            return [undefined, Promise_1.default.all(results)];
        }
        if (typeof ref !== 'string') {
            return [ref, undefined];
        }
        return [undefined, registry.getAction(ref)];
    }
    function resolveListenersMap(registry, listeners) {
        if (!listeners) {
            return null;
        }
        var map = {};
        var eventTypes = Object.keys(listeners);
        return eventTypes.reduce(function (promise, eventType) {
            var _a = resolveListeners(registry, listeners[eventType]), value = _a[0], listenersPromise = _a[1];
            if (value) {
                map[eventType] = value;
                return promise;
            }
            return listenersPromise.then(function (value) {
                map[eventType] = value;
                return promise;
            });
        }, Promise_1.default.resolve(map));
    }
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.default = resolveListenersMap;
});
//# sourceMappingURL=resolveListenersMap.js.map